from summer.templates import RoleDetail, RoleList, UserDetail, UserList, ProductGroupList, ProductGroupDetail
from summer.views.user import show_list as user_list, user_info, save_user, update_user
from summer.views.role import show_list as role_list, role_info, save_role, update_role
from summer.views.product_group import show_list as product_group_list, product_group_info, save_product_group, \
    update_product_group

__author__ = 'tanshu'


class Router():
    def __init__(self):
        self.user_list_form = None
        self.user_detail_form = None
        self.role_list_form = None
        self.role_detail_form = None
        self.product_group_list_form = None
        self.product_group_detail_form = None

    def show_users(self):
        users = user_list()
        if self.user_list_form is None:
            self.user_list_form = UserList(self, users)
            self.user_list_form.destroyed.connect(self.user_list_form_destroyed)
        self.user_list_form.show()

    def user_list_form_destroyed(self):
        self.user_list_form = None

    def show_user(self, id=None):
        user = user_info(id)
        if self.user_detail_form is None:
            self.user_detail_form = UserDetail(self, user)
            self.user_detail_form.destroyed.connect(self.user_detail_form_destroyed)
        self.user_detail_form.show()

    def user_detail_form_destroyed(self):
        self.user_detail_form = None
        if self.user_list_form is not None:
            self.user_list_form.update_data(user_list())

    def save_user(self, user):
        if 'UserID' not in user:
            save_user(user)
        else:
            update_user(user)


    def show_roles(self):
        roles = role_list()
        if self.role_list_form is None:
            self.role_list_form = RoleList(self, roles)
            self.role_list_form.destroyed.connect(self.role_list_form_destroyed)
        self.role_list_form.show()

    def role_list_form_destroyed(self):
        self.role_list_form = None

    def show_role(self, id=None):
        role = role_info(id)
        if self.role_detail_form is None:
            self.role_detail_form = RoleDetail(self, role)
            self.role_detail_form.destroyed.connect(self.role_detail_form_destroyed)
        self.role_detail_form.show()

    def role_detail_form_destroyed(self):
        self.role_detail_form = None
        if self.role_list_form is not None:
            self.role_list_form.update_data(role_list())

    def save_role(self, role):
        if 'RoleID' not in role:
            save_role(role)
        else:
            update_role(role)


    def show_product_groups(self):
        product_groups = product_group_list()
        if self.product_group_list_form is None:
            self.product_group_list_form = ProductGroupList(self, product_groups)
            self.product_group_list_form.destroyed.connect(self.product_group_list_form_destroyed)
        self.product_group_list_form.show()

    def product_group_list_form_destroyed(self):
        self.product_group_list_form = None

    def show_product_group(self, id=None):
        product_group = product_group_info(id)
        if self.product_group_detail_form is None:
            self.product_group_detail_form = ProductGroupDetail(self, product_group)
            self.product_group_detail_form.destroyed.connect(self.product_group_detail_form_destroyed)
        self.product_group_detail_form.show()

    def product_group_detail_form_destroyed(self):
        self.product_group_detail_form = None
        if self.product_group_list_form is not None:
            self.product_group_list_form.update_data(product_group_list())

    def save_product_group(self, product_group):
        if 'ProductGroupID' not in product_group:
            save_product_group(product_group)
        else:
            update_product_group(product_group)
